plugin simpleObject lidBox
name:"lidBox"
classid:#(0x34570181, 0x6e9f1c72)
category:"por MAVDigital"
(
parameters main rollout:params
(
length type:#float default:0 ui:spn_length
width type:#float default:0 ui:spn_width
thickness type:#float default:1 ui:spn_thickness
height type:#float default:0 ui:spn_height
	
lengthSegs type:#integer default:1 ui:spn_lengthSegs
widthSegs type:#integer default:1 ui:spn_widthSegs
heightSegs type:#integer default:1 ui:spn_heightSegs	
	
useLid type:#boolean default:false ui:chk_useLid
open type:#float default:0 ui:spn_open
usePivots type:#boolean default:true ui:chk_usePivots
pivotSize type:#float default:10 ui:spn_pivotSize
pivotRadius type:#float default:1 ui:spn_pivotRadius

)
rollout params "LidBox Parameters"
(
group "Dimensiones"
(
spinner spn_length "Length" range:[0,100000,0]
spinner spn_width "Width" range:[0,100000,0]
spinner spn_height "Height" range:[0,100000,0]
spinner spn_thickness "Thickness" range:[0.01,100000,1]
)
group "Segmentos"
(
spinner spn_lengthSegs "Length Segs" range:[1,10,1] type:#integer
spinner spn_widthSegs "Width Segs" range:[1,10,1] type:#integer	 
spinner spn_heightSegs "Height Segs" range:[1,10,1] type:#integer	 	
)
group "Parmetros de la tapa"
(
spinner spn_pivotSize "Pivot Size" range:[0.01,100,10]
spinner spn_pivotRadius "Pivot Radius" range:[0.01,100,10]
	
checkBox chk_useLid "Lid" across:2
checkBox chk_usePivots "Pivots"
	
spinner spn_open "Open %" range:[0,100,0]
)	
)
fn transformMesh theMesh theTM matID:1 =
(
for v = 1 to theMesh.numverts do
setVert theMesh v ((getVert theMesh v)*theTM) 
for f = 1 to theMesh.numfaces do setFaceMatID theMesh f matID
theMesh
)
on buildMesh do
(
bottomBox = createInstance box width:(width-2.01*thickness) length:(length-2.01*thickness) height:thickness lengthSegs:lengthSegs widthSegs:widthSegs heightSegs:1 mapcoords:true
sideBox = createInstance box width:(thickness) length:(length-2.01*thickness) height:height lengthSegs:lengthSegs widthSegs:1 heightSegs:heightSegs mapcoords:true
frontBox = createInstance box width:(width) length:(thickness) height:height  lengthSegs:1 widthSegs:widthSegs heightSegs:heightSegs mapcoords:true
--- mesh = bottomBox.mesh
	
theTM = matrix3 1
mesh = transformMesh bottomBox.mesh theTM
	
theTM.row4 = [-width/2+thickness/2,0,0]
mesh += transformMesh sideBox.mesh theTM

theTM.row4 = [width/2-thickness/2,0,0]
mesh += transformMesh sideBox.mesh theTM

theTM.row4 = [0,-length/2+thickness/2,0]
mesh += transformMesh frontBox.mesh theTM

theTM.row4 = [0,length/2-thickness/2,0]
mesh += transformMesh frontBox.mesh theTM		

if useLid do
(
LidBox = createInstance box width:width length:length height:thickness  lengthSegs:lengthSegs widthSegs:widthSegs heightSegs:1 mapcoords:true
theLidMatrix = matrix3 1
theLidMatrix.row4 = [0,-length/2,0]
theLidMatrix *= rotateXMatrix (-180.0*open/100)
translate theLidMatrix [0,length/2,height+thickness*0.01] 
mesh += transformMesh lidBox.mesh theLidMatrix
	
if usePivots do
(
pivotCylinder = createInstance cylinder radius:PivotRadius height:PivotSize Sides:8 mapcoords:true
thePivotTM = Matrix3 1
thePivotTM *= rotateYMatrix 90
thePivotTM.row4 = [-width/4-pivotSize/2,length/2,height]
local theMesh = transformMesh pivotCylinder.mesh thePivotTM matID:2
--- 2 ---	
thePivotTM = Matrix3 1
thePivotTM *= rotateYMatrix -90
thePivotTM.row4 = [width/4+pivotSize/2,length/2,height]
mesh+= theMesh + (transformMesh pivotCylinder.mesh thePivotTM matID:2)
delete theMesh
)
)
)
tool create
(
on mousePoint click do
(
case click of
(
1: nodeTM.translation = gridPoint
3: #stop
)
)
on mouseMove click do
(
case click of
(
2: (width = abs gridDist.x*2; length = abs gridDist.y*2)
3: height = abs gridDist.z
)
)
)
on attachedToNode theNode do
(
if theNode.material == undefined do --- error ---
(
theMultiMat = multiMaterial name:"LidBoix" numsubs:2
theWoodMap = bitmapTexture fileName:"ASHSEN_2.GIf"
theMultiMat[1] = standard diffuse:[200,100,50] diffuseMap: theWoodMap
theMultiMat[2] = standard diffuse:[200,200,200]
theNode.material = theMultiMat
ShowTextureMap theMultiMat[1] theWoodMap true
)
)
)--- end Plugin